.686
.model flat,stdcall
option casemap:none
include windows.inc
include stdio.inc
include asmlib.inc

.code

IsPandigital9 proc n
	LOCAL AllDigits
	mov ecx,n
	mov edx,3817748708;MagicNumber for div 9
	mov eax,ecx
	mul edx
	shr edx,3
	mov eax,ecx
	lea edx,[edx*2+edx];*3
	xor ecx,ecx
	lea edx,[edx*2+edx];*3
	mov AllDigits,ecx
	.if eax == edx && eax >= 123456789; passed divisibility test & smallest test
		rept 9
		mov ecx,eax
		mov edx,3435973837;MagicNumber for div 10
		mul edx
		shr edx,3
		lea eax,[edx*4+edx]
		add eax,eax
		sub ecx,eax
		mov eax,edx
		mov edx,1
		shl edx,cl
		or AllDigits,edx
		endm
		.if AllDigits == 1111111110b;; restricted pandigital test passed
			return 1
		.endif
	.endif
	return 0
IsPandigital9 endp


PanFib proc uses esi edi ebx maxk
	LOCAL K:DWORD,T1:DWORD
	LOCAL syscw:word,mycw:word
	LOCAL Ticks

	.data
	ALIGN 16
	LOG10PHI REAL10 0.208987640249978733769;Log10((Sqrt[5] + 1)/2)
	ALIGN 8
	RECSQRT5 REAL8 0.447213595499957939281;1/Sqrt[5]
	
	.code

	invoke GetTickCount
	mov Ticks,eax

	FNSTCW syscw
	xor ebx,ebx
	xor esi,esi
	lea edi,[ebx+1]
	xor eax,eax
	inc ebx
	mov ax,syscw
	or ax,110000000000b;; BITS 10 11 Trunc
	mov mycw,ax
	FLD LOG10PHI
	FLD st

	.repeat
		mov K,ebx
		; Check Last 9 Digits
		lea ecx,[edi+esi]
		mov edi,esi
		cmp ecx,1000000000
		sbb esi,esi
		xor esi,-1
		and esi,-1000000000
		add esi,ecx
		invoke IsPandigital9,esi
		.if eax

			; Check First 9 Digits
			
			;;
			;; Benet's Formula
			;;
			
			;for small k the result is incorrect
			FILD K
			FMUL
			FLD ST
			FLDCW mycw
			FRNDINT; Without truncation gives == digits
			FLDCW syscw
			FIST T1
			FSUB; Get fractional part
			; Check For 0.
			CMP T1,1
			SBB EAX,EAX
			AND EAX,1000000000-100000000
			ADD EAX,100000000; 1E8
			MOV T1,EAX
			; Perform ( 10^FractionalPart/Sqrt(5) )
			fldl2t
			fmul
			fld  st
			FLDCW mycw
			FRNDINT;round it to an integer
			FLDCW syscw
			fsub st(1),st ; fraction
			fxch st(1)
			f2xm1
			fld1
			fadd
			fscale
			fstp st(1)
			;; Multiply By 1/SQRT(5)
	        FMUL RECSQRT5
			FIMUL T1; Get Integer For Digits
			FLDCW mycw
			FISTP T1
			FLDCW syscw
			; Check for Pandigitality
			invoke IsPandigital9,T1
			.if eax
				invoke GetTickCount
				mov edx,Ticks
				mov Ticks,eax
				sub eax,edx
				invoke printf,T('Fk Found! K=%u, First9="%u", Last9="%u", Ticks=%u',13,10),K,T1,esi,eax
			.endif
			FLD ST

		.endif 
		inc ebx
	.until ebx >= maxk
	FSTP ST
	ret
	
PanFib endp


main proc C uses esi edi ebx argc:dword,argv:ptr dword

	invoke InitConsole
	invoke TextColor,ccWhite
	invoke SetConsoleTitle,T('Fib test')
	mov ebx,999999999
	invoke PanFib,ebx
	invoke printf,T(13,10,'Fib test finished. Tested up to K=%u'),ebx
	invoke getchar
	return ERROR_SUCCESS

main endp

end
